/*  


ͻ
 Programa  RELFAL    Autor Manoel Carlos Junior Data              
͹
Descricao  Imprime um Relatorio com os Saldos em estoque dos pordutos 
           da ordem de producao.                                      
͹
Modulo    | SIGAEST  | USO | Especifico do SIGAEST                     
ͼ


*/        

#Include "protheus.CH"
#Include "REPORT.CH"
#INCLUDE "FWCOMMAND.CH"
 
User Function RELFAL()

Local oReport
Local oSection1
Local oSection2
Local oBreak
Local cPerg := "RELFAL"


CriaSX1(cPerg)
Pergunte(cPerg, .F.)



DEFINE REPORT oReport NAME "RELFAL" TITLE "RELATORIO DE FALTAS" PARAMETER cPerg ACTION {|oReport| PrintReport(oReport, cPerg)}

DEFINE SECTION oSection1 OF oReport TITLE "Cabealho" TABLES "SD4"

TRCell():New(oSection1,"D4_FILIAL","SD4","Filial",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"D4_OP","SD4","NOp.",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"D4_COD","SD4","Produto",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"B1_DESC","SB1","Descrio",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"D4_LOCAL","SD4","Armazem",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"TOTAL","SD4","Saldo",,,,,,,,,,,,,,,.F.)



//oBreakCli:OnPrintTotal( { || oReport:EndPage() } ) 




oReport:EndPage()
oReport:SetLandScape(.F.)

oReport :PrintDialog()


Return Nil

//----------------------------------------------------------------------------------------------------------------//


Static Function PrintReport(oReport, cPerg)

Local oSection1  	:= oReport:Section(1)
Local oSection2  	:= oReport:Section(2)
Local nOrdem 		:= oSection1:GetOrder()
Local oBreak


#IFDEF TOP
	
	Local cAlias := GetNextAlias()
	Local cSQL := ""
	
	MakeSqlExp(cPerg)
	
	If !Empty(mv_Par01)
		cSQL += "AND D4_OP >= '" + mv_Par01 + "' "
	EndIf
	If !Empty(mv_Par02)
		cSQL += "AND D4_OP  <= '" + mv_Par02 + "' "
	EndIf
	
	If !Empty(mv_Par05)
		cSQL += "AND D4_FILIAL >= '" + mv_Par03 + "' "
	EndIf
	If !Empty(mv_Par06)
		cSQL += "AND D4_FILIAL <= '" + mv_Par04 + "' "
	EndIf
	
	If !Empty(mv_Par07)
		cSQL += "AND D4_LOCAL >= '" + mv_Par05 + "' "
	EndIf
	
 	If !Empty(mv_Par06)
		cSQL += "AND D4_LOCAL <= '" + mv_Par06 + "' "
	EndIf	
	
	
	cSQL := "%"+cSQL+"%"
	
	BEGIN REPORT QUERY oReport:Section(1)
	
		BeginSQL Alias cAlias
	        
			SELECT  D4_FILIAL, D4_OP, D4_COD, D4_LOCAL, B1_DESC, B2_QATU, B2_RESERVA,B2_QEMP, B2_QEMPSA, 
	              SB2.B2_QATU-SB2.B2_RESERVA-SB2.B2_QEMP-SB2.B2_QEMPSA AS TOTAL
			FROM 	%Table:SD4% SD4 INNER JOIN  %Table:SB1% SB1 ON 
					   SB1.B1_COD = SD4.D4_COD  
			     AND SB1.B1_FILIAL = '01' 
			INNER JOIN  %Table:SB2% SB2 ON 
					   SB2.B2_FILIAL = SD4.D4_FILIAL 
			    AND  SB2.B2_COD    = SD4.D4_COD 
	          AND  SB2.B2_LOCAL  = SD4.D4_LOCAL    
		  	    
				WHERE 	SD4.%NotDel% 
	  		      AND 	SB1.%NotDel%
	      	   AND   SB2.%NotDel%
			%Exp:cSQL%       
               	
			ORDER BY  D4_OP, D4_COD, B1_DESC,D4_LOCAL

	
		EndSQL
		

	
	END REPORT QUERY oReport:Section(1)    

   
	
  oSection1:SetParentQuery()
  oSection1:SetParentFilter({|cNum| (cAlias)->D4_OP == cNum}, {|| (cAlias)->D4_OP})  
                           
  
  oSection1:Print()
    
#ELSE

   MakeAdvplExpr(cPerg)
	
   dbSelectArea("SZ1")
   dbSetOrder(1)
	
   If !Empty(mv_Par01)
      oReport:Section(1):SetFilter(mv_Par01)               // mv_Par01 contem a range de Contas.
   EndIf

   oReport:Section(1):Section(1):SetParentFilter({|cCodigo| SZ2->Z2_CODCOR == cCodigo}, {|| SZ1->Z1_CODIGO})
   oReport:Section(1):Section(1):SetLineCondition({|| SZ2->Z2_Data >= mv_Par02 .And. SZ2->Z2_Data <= mv_Par03 .And. Z2_Tipo $ IIf(mv_Par04==1,"12",If(mv_Par04==2,"1","2"))})
   
   oReport:Section(1):Print()

#ENDIF

Return Nil

//----------------------------------------------------------------------------------------------------------------//
// Parametros que devem ser passados para a funo de criao das perguntas no arquivo SX1.
//----------------------------------------------------------------------------------------------------------------//
//  1o. Parametro -> Nome do grupo
//  2o. Parametro -> Numero da ordem
//  3o. Parametro -> Texto da pergunta em portugues
//  4o. Parametro -> Texto da pergunta em espanhol
//  5o. Parametro -> Texto  da pergunta em ingles
//  6o. Parametro -> Nome da variavel
//  7o. Parametro -> Tipo do dado C=caractere, D=Data, N=Numerico
//  8o. Parametro -> Tamanho do dado
//  9o. Parametro -> Quantidade de casas decimais para o dado
// 10o. Parametro -> Numero da pre-selecao
// 11o. Parametro -> O tipo do dado sera G=get, S=scroll, C=choice, R=Range
// 12o. Parametro -> Sintaxe em advpl, ou funcao para validacao
// 13o. Parametro -> Consistencia com alguma tabela do sistema via <F3>
// 14o. Parametro -> Nome do grupo para SXG
// 15o. Parametro -> Pyme
// 16o. Parametro -> Nome da variavel que ser utilizada no programa
// 17o. Parametro -> Primeira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 18o. Parametro -> Primeira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 19o. Parametro -> Primeira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 20o. Parametro -> Conteudo da ultima resposta informada no parametro se caso o tipo do dados for get
// 21o. Parametro -> Segunda definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 22o. Parametro -> Segunda definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 23o. Parametro -> Segunda definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 24o. Parametro -> Terceira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 25o. Parametro -> Terceira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 26o. Parametro -> Terceira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 27o. Parametro -> Quarta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 28o. Parametro -> Quarta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 29o. Parametro -> Quarta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 30o. Parametro -> Quinta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 31o. Parametro -> Quinta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 32o. Parametro -> Quinta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 33o. Parametro -> Vetor com o texto do help em portugues
// 34o. Parametro -> Vetor com o texto do help em espanhol
// 35o. Parametro -> Vetor com o texto do help em ingles
// 36o. Parametro -> Nome do grupo do help

Static Function CriaSX1(cPerg)                                                                                                           

Local aHelp := {}

//            Texto do help em portugus                , ingls, espanhol
AAdd(aHelp, {{"No. OP inicial a ser considerado na filtragem do cadastro de OPs (SD4). "}, {""}, {""}})
AAdd(aHelp, {{"No. OP final a ser considerado na filtragem do cadastro de OPs (SD4). "}, {""}, {""}})
AAdd(aHelp, {{"Digite o digo da Filial. "}, {""}, {""}})
AAdd(aHelp, {{"Digite o digo da Filial. "}, {""}, {""}})
AAdd(aHelp, {{"Armazem inicial a ser considerado na filtragem no cadastro de Saldos (SB2). "}, {""}, {""}})
AAdd(aHelp, {{"Armazem final a ser considerado na filtragem no cadastro de Saldos (SB2). "}, {""}, {""}})
        
//	  	  1o  2o     3o           4  5   6o      7  8  9  10 11  12  13   14 15    16      17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32   33           34         35     36 
PutSX1(cPerg,"01","De OP"	,"","","mv_ch1","C",13,00,00,"G","","SC2","","","mv_Par01","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
PutSX1(cPerg,"02","At OP"  ,"","","mv_ch2","C",13,00,00,"G","","SC2","","","mv_Par02","","","","","","","","","","","","","","","","",aHelp[2,1],aHelp[2,2],aHelp[2,3],"")
PutSX1(cPerg,"03","De Filial"  ,"","","mv_ch3","C",04,00,00,"G","","","","","mv_Par03","","","","","","","","","","","","","","","","",aHelp[3,1],aHelp[3,2],aHelp[3,3],"")
PutSX1(cPerg,"04","At Filial"  ,"","","mv_ch4","C",04,00,00,"G","","","","","mv_Par04","","","","","","","","","","","","","","","","",aHelp[4,1],aHelp[4,2],aHelp[4,3],"")
PutSX1(cPerg,"05","Do Armazem"  ,"","","mv_ch5","C",02,00,00,"G","","","","","mv_Par05","","","","","","","","","","","","","","","","",aHelp[5,1],aHelp[5,2],aHelp[5,3],"")
PutSX1(cPerg,"06","At Armazem"  ,"","","mv_ch6","C",02,00,00,"G","","","","","mv_Par06","","","","","","","","","","","","","","","","",aHelp[6,1],aHelp[6,2],aHelp[6,3],"")

Return 
